package cn.ibizlab.humanresource.core.base.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.base.domain.HROMHierarchyCat;
import cn.ibizlab.humanresource.core.base.filter.HROMHierarchyCatSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HROMHierarchyCat] 服务对象接口
 */
public interface IHROMHierarchyCatService extends IService<HROMHierarchyCat>{

    boolean create(HROMHierarchyCat et) ;
    void createBatch(List<HROMHierarchyCat> list) ;
    boolean update(HROMHierarchyCat et) ;
    void updateBatch(List<HROMHierarchyCat> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HROMHierarchyCat get(String key) ;
    HROMHierarchyCat getDraft(HROMHierarchyCat et) ;
    boolean checkKey(HROMHierarchyCat et) ;
    boolean save(HROMHierarchyCat et) ;
    void saveBatch(List<HROMHierarchyCat> list) ;
    Page<HROMHierarchyCat> searchDefault(HROMHierarchyCatSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HROMHierarchyCat> getHromhierarchycatByIds(List<String> ids) ;
    List<HROMHierarchyCat> getHromhierarchycatByEntities(List<HROMHierarchyCat> entities) ;
}


